/*****************************************************************************
 *
 * utouch-grail - Multitouch Gesture Recognition Library
 *
 * Copyright (C) 2011 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 ****************************************************************************/

#ifndef UTOUCH_GRAIL_FORWARD_H_
#define UTOUCH_GRAIL_FORWARD_H_

#include <memory>
#include <set>

#include <utouch/frame.h>

namespace utouch {
namespace grail {

class UGEvent;
typedef std::shared_ptr<UGEvent> SharedUGEvent;

class Gesture;
typedef std::shared_ptr<Gesture> SharedGesture;

class UGHandle;
typedef std::shared_ptr<UGHandle> SharedUGHandle;

class Recognizer;
typedef std::shared_ptr<Recognizer> SharedRecognizer;

class UGSlice;
typedef std::shared_ptr<UGSlice> SharedUGSlice;

class UGSubscription;
typedef std::shared_ptr<UGSubscription> SharedUGSubscription;

typedef std::set<UFTouchId> TouchSet;

} // namespace grail
} // namespace utouch


#endif // UTOUCH_GRAIL_FORWARD_H_
